export = Message;
/**
 * @typedef {0|1|2|3|4} ConnectionType
 *
 * @typedef {object} PBPeer
 * @property {Uint8Array} id
 * @property {Uint8Array[]} addrs
 * @property {ConnectionType} connection
 *
 * @typedef {import('../index').PeerData} PeerData
 */
/**
 * Represents a single DHT control message.
 */
declare class Message {
    /**
     * Decode from protobuf
     *
     * @param {Uint8Array} raw
     */
    static deserialize(raw: Uint8Array): import(".");
    /**
     * @param {MESSAGE_TYPE} type
     * @param {Uint8Array} key
     * @param {number} level
     */
    constructor(type: any, key: Uint8Array, level: number);
    type: any;
    key: Uint8Array;
    _clusterLevelRaw: number;
    /** @type {PeerData[]} */
    closerPeers: PeerData[];
    /** @type {PeerData[]} */
    providerPeers: PeerData[];
    /** @type {import('libp2p-record').Record | null} */
    record: import('libp2p-record').Record | null;
    set clusterLevel(arg: number);
    /**
     * @type {number}
     */
    get clusterLevel(): number;
    /**
     * Encode into protobuf
     */
    serialize(): any;
}
declare namespace Message {
    export { MESSAGE_TYPE as TYPES, CONNECTION_TYPE as CONNECTION_TYPES, ConnectionType, PBPeer, PeerData };
}
type PeerData = {
    id: PeerId;
    multiaddrs: multiaddr[];
};
declare const MESSAGE_TYPE: any;
declare const CONNECTION_TYPE: any;
type ConnectionType = 0 | 3 | 1 | 4 | 2;
type PBPeer = {
    id: Uint8Array;
    addrs: Uint8Array[];
    connection: ConnectionType;
};
import PeerId = require("peer-id");
import multiaddr = require("multiaddr");
//# sourceMappingURL=index.d.ts.map